﻿namespace Butterfly
{
    using Butterfly.Core;
    using ConsoleWriter;
    using System;
    using System.Runtime.CompilerServices;
    using System.Runtime.InteropServices;
    using System.Security.Permissions;
    using System.Windows.Forms;

    internal class Program
    {
        [MTAThread]
        internal static void InitEnvironment()
        {
            if (!ButterflyEnvironment.isLive)
            {
                Console.ForegroundColor = ConsoleColor.White;
                Console.CursorVisible = false;
                AppDomain.CurrentDomain.UnhandledException += new UnhandledExceptionEventHandler(Program.MyHandler);
                ButterflyEnvironment.Initialize();
            }
        }

        [STAThread, SecurityPermission(SecurityAction.Demand, Flags=SecurityPermissionFlag.ControlAppDomain)]
        internal static void Main()
        {
            Writer.Init();
            string startupPath = Application.StartupPath;
            InitEnvironment();
            while (true)
            {
                Console.CursorVisible = true;
                if (Logging.DisabledState)
                {
                    Console.Write("btrstrm> ");
                }
                ConsoleCommandHandeling.InvokeCommand(Console.ReadLine());
            }
        }

        private static void MyHandler(object sender, UnhandledExceptionEventArgs args)
        {
            Logging.DisablePrimaryWriting(true);
            Logging.LogCriticalException("SYSTEM CRITICAL EXCEPTION: " + ((Exception) args.ExceptionObject).ToString());
            ButterflyEnvironment.SendMassMessage("A fatal error crashed the server, server shutting down.");
            ButterflyEnvironment.PreformShutDown(true);
        }

        [DllImport("Kernel32")]
        private static extern bool SetConsoleCtrlHandler(EventHandler handler, bool add);

        private enum CtrlType
        {
            CTRL_BREAK_EVENT = 1,
            CTRL_C_EVENT = 0,
            CTRL_CLOSE_EVENT = 2,
            CTRL_LOGOFF_EVENT = 5,
            CTRL_SHUTDOWN_EVENT = 6
        }

        private delegate bool EventHandler(Program.CtrlType sig);
    }
}

